/*
 *  itc.cpp
 *  itc
 *
 *  Created by Yoonsoo Kim on 08. 10. 27.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

#include "itc.h"

using namespace std;
using namespace boost;

namespace itc { 

WaitAndExecute::WaitAndExecute() :
	m_mutex(), m_cond(), m_req(false), m_callQ()
	{}

void
WaitAndExecute::queue(CallType call)
{
	unique_lock<mutex> lock(m_mutex);
	m_callQ.push(call);
	m_req = true;
	m_cond.notify_one();
}

void
WaitAndExecute::execute()
{
	unique_lock<mutex> lock(m_mutex);
	// wait
	while (!m_req)
	{
		m_cond.wait(lock);
	}

	// execute
	while (!m_callQ.empty())
	{
		m_callQ.front()();
		m_callQ.pop();
	}
	m_req = false;	
}

ProcessAndExecute::ProcessAndExecute() : 
	m_mutex(), m_callQ()
	{}

void
ProcessAndExecute::queue(CallType call)
{
	unique_lock<mutex> lock(m_mutex);
	m_callQ.push(call);
}

void
ProcessAndExecute::execute()
{
	CallType call;
	bool req = false;

	// process
	process();

	// execute
	{
		unique_lock<mutex> lock(m_mutex);
		if (!m_callQ.empty())
		{
			call = m_callQ.front();
			m_callQ.pop();
			req = true;
		}
	}
	
	if (req)
		call();		
}

};
